#!/usr/bin/perl -w

################################INFO######################################
##
#           Blackmore's utilities 1.0 - script for X-Chat 
#              Copyright (C) 2002-2007 Simeon Simeonov
#       
#       
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License 2 as published by
# the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
####

## Blackmore's utilities is a set of small script intended to make your
# XChat client more flexible.
# The script collection will grow in time.


## SCRIPTS ##

## The name of the match command used to return every nick that matches certain hostmask.
# Default = match. Usage: /match <hostmask>
# Example: /match *.chello.no 
##
$match_cmd = "match";

## The name of the rmatch command used to return every nick that matches certain regexp.
# Default = rmatch. Usage: /rmatch <regexp>
# Example: /rmatch .*\.chello.no$ 
##
$rmatch_cmd = "rmatch";


Xchat::register("Blackmore's utilities", "1.0", "Set of useful scripts", "");

Xchat::hook_command($match_cmd, "pub_match");
Xchat::hook_command($rmatch_cmd, "pub_rmatch");

### Host match expressions!! ###
sub pub_match {
	
	my($mhost) = $_[0][1];

	$mhost =~ s/\./\\\./g;
	$mhost =~ s/\?/./g;
	$mhost =~ s/\*/.*/g;
	
	@hash_list = Xchat::get_list("users");
	
	if (defined $_[0][2]) { Xchat::print("RegExp: $mhost\n"); }
	
	Xchat::print("---MATCHES---");	
	foreach $user_hash ( @hash_list ) {

		if ($user_hash->{host} =~ /$mhost/i) {
			Xchat::print("$user_hash->{nick} ($user_hash->{host})");
		}
	}
	Xchat::print("-----END-----");

	return Xchat::EAT_XCHAT;
}


sub pub_rmatch {
	
	my($mhost) = $_[0][1];

	@hash_list = Xchat::get_list("users");
	
	if (defined $_[0][2]) { Xchat::print("RegExp: $mhost\n"); }
	
	Xchat::print("---MATCHES---");	
	foreach $user_hash ( @hash_list ) {

		if ($user_hash->{host} =~ /$mhost/i) {
			Xchat::print("$user_hash->{nick} ($user_hash->{host})");
		}
	}
	Xchat::print("-----END-----");

	return Xchat::EAT_XCHAT;
}


Xchat::print("Blackmore's utilities 1.0 loaded!!\n");
